# Contributing to an open source project

This is one of the main evalutation point for this course. You are tasked with contributing to an opensource project. The contribution might be really small. The technical aspect of the contribution will not be evaluated. Games are more than welcome (games are wonderful engineering achievements).

What will be important:
- Choice of the project 
- Relationship with the community
- Understanding the contribution process
- Understanding the project you contributed to : license, team, processes

## Report

The report should be a journal written in markdown format pushed to this repository. Look at what others did the previous year.

## Collaboration

Collaboration is encouraged between student. Reuse of existing documents is also encouraged. Both are seen as a smart use of your time. 

But transparency is crucial. Each part of the report that has been written in collaboration should be clearly indicated. The source of every imported material should be mentioned, potentially with the license.

## Deadline

The soft deadline is two weeks before blocus. Students will present their projects in front of the class during a 5 minutes talk without slides (but a demo is accepted).

The hard deadline for those who missed the soft one is the exam. And the fact that the teacher should read it before your exam. So take your responsibility.




## How to do that?

First, you will have to deal with other people. You will need patience. So start really early. This project can, in most case, be completed easily with less than 30 minutes every week. Unfortunately, it cannot be completed in one week, even working full time on it. So start early!


1. If you are using a proprietary OS, install a free one of your choice (Any GNU/Linux, Freebsd, openbsd or others).
2. Follow a git tutorial and try to get acquainted with git. Git is bread and butter for any developer.
3. Explore the software you use and try to find if there are any opensource. Discuss with others.
4. Once you found an interesting project, git checkout and try to build it locally. You have succeeded only if you can run the version you compiled yourself. This part might be trivial or be really hard, depending on the project. If it’s hard, consider contributing to the documentation to make it easier.
5. Make a trivial change in the project to ensure you can modify the code and run it. Congratulations, you made it!
6. If you made it so fare, explore the bug tracker to see what you could do. Most projects have "easy" bugs kept for beginners. Try to contact the community on the chat or the forum. Try to understand who is doing what. See if the project is active. Does it make sense to contributed to a project without any activity for years? (sometimes, yes, but better check beforehand)
7. Code
8. Submit your Pull Request (PR)
9. Get feedbacks, fix your code and go back to 7 while not accepted.

As you can see, the code itself is the smallest part of the project. Don’t spend too much time on it without clear objectives and guidance from the community. Nobody likes to receive a huge blob of code from nowhere written by an inexperienced student. If you do so, your patch will probably be ignored or rejected.
