# Open Source Contribution Project
*Author :* Martin Vandenbussche  
*Date :* November 2019  
*NOMA :* 02441500

## Research and Selection of the Project

During the month of October, I looked around on Github for medium-sized open source projects to contribute to. This search took me quite a while, because I wanted to find a project that motivated me, something that I would use personally in other contexts. I also had to find a project that was written in one of the few languages I consider myself good enough at, and that had a large and active community supporting it.  
My choice finally landed on [Java Design Patterns](https://github.com/iluwatar/java-design-patterns) which is a small website presenting a large collection of programming design patterns. Each of them has its own page, presenting the general principle behind it, with real-world as well as program examples coded in Java. One thing I found particularly interesting with this project is the emphasis put by the community on the quality and the performance of the code; I thought this was also a great opportunity to learn about modern Java features as well as good programming practices in general.  
You can find my original pull request to the course repository [here](https://github.com/ploum/lingi2401/pull/96).

## Contributions

My first actions were to read the contribution guidelines of the project, as well as the overall documentation describing the coding conventions, testing policy, etc. I then forked the repository and started working on [Issue#1055](https://github.com/iluwatar/java-design-patterns/issues/1055). I submitted my first [pull request](https://github.com/iluwatar/java-design-patterns/pull/1088) on November 14, which got approved and merged on November 16. This issue asked to extend the existing code examples presenting the Specification programming pattern; in particular, I presented the concept of "parameterized specification". Another [issue](https://github.com/iluwatar/java-design-patterns/issues/1093) was then raised, asking to present the related concept of "composite specification". I presented a pull request for this issue (accessible [here](https://github.com/iluwatar/java-design-patterns/pull/1094)) on November 17, which was accepted the same day.
You can see the result of those contributions on the [Java Design Patterns website](https://java-design-patterns.com/patterns/specification/); it is both a technical contribution (the code required was of decent length, and required some understanding of different libraries, especially for the unit tests, which implied reading quite a lot of documentation), and a "literary" contribution (the writing of the actual MarkDown document presenting how to use and understand the pattern).
