# Open Source Contribution Project
*Author :* Amaury Doneux

*NOMA :* 01281500

*Date :* January 2021

*Selected project :* [Exercism](https://github.com/exercism/java)

## Research and selection of a project

I coudn't find any open source project that I was using. So I checked the open source projects that were flagged as "Great for new contributors". Within those projects, one caught my attention [HospitalRun](https://github.com/HospitalRun/hospitalrun-frontend).

Unfortunately, I let some time go by and as I didn't have that much time left, I decided to move to another project (maybe I'll come back to this one later as I still think it's a good project). 
I tried to get some info on the [NodeJS](https://github.com/nodejs/node) project but it did seem a little to big as a first participation.

Finally, as time was flying, I decided to go for the [Exercism](https://github.com/exercism/java) project (the Java track). Indeed, some other students talked previously about it. So it seemed like a good project to start with for a first contribution to the open source world.

## Getting acquainted with the project

The first thing I did was to go to the main page of the Exercism project on github. This is where I learned by reading the README that the project was divided in "tracks" (one by language). In the README it was recommended to do some exercises on the platform before trying to contribute to the project to get a feeling of how the project was working. So, choosing the Java track I did some exercises on the platform and I found it quite interesting. I am currently doing the Java track but will surely do some other tracks after this one, as I discovered that Exercism is really usefull. Theay even have a system of mentor that can give you feedback on your solutions ! If you haven't ever done an exercise on Exercism, I really recommend you to do so, it is really worth it !

So after making some exercises and reading how the Java track was working, it was time to find a way to contribute to the project.

## Search of a contribution to make

To find what contribution I would do, I first checked the different issues and the different PR. I discovered that most issues were already attributed to someone (some were even attributed more than a year ago). But most of them were still unresolved which surprised me. 

After thinking, I realised that while doing an exercise, I had found that the description was not detailed enough. So I made an [Issue](https://github.com/exercism/java/issues/1855) about it.

And did my [PR](https://github.com/exercism/java/pull/1856).

I also reported another [Issue](https://github.com/exercism/java/issues/1857) for some dead links on the website.

I didn't receive any answer to the issues I reported, nor to my PR, but I think it is normal as the V3 of Exercism should be released near the end of january. So most people are working on that part for now.

## Conclusion

Even though my PR hasn't been accepted yet, I already learned a lot. I know the different steps necessary to participate to an open source project. As I know how the Exercism project  works, I will try to continue to contribute to it. My hopes are that I will be able to continue to contribute to this project and if I can, I will try to find one or two other projects in which I can also participate. This way, I won't forget what I learned and will be able to learn more from the different projects. Plus, of course, it is a great way to build my CV.

# Exam

## L'histoire du projet OpenOffice.org
* Vient de StarOffice (développé par StarDivision)
* En 1999, rachat de StarDivision par Sun Microsystem qui rend le code publique sous LGPL.
* But : proposé une suite bureautique libre et gratuite, alternative a Microsoft Office (solution propriétaire).
* Donc naissance du projet OpenOffice.org.
* Brièvement développé par Oracle suite au rachat de Sun Microsystem.
* Fork par la communauté car manque d'investessement de la part d'Oracle sur le projet.
* Naissance de LibreOffice.
* Oracle cède le projet à la fondation Apache. 
* Apparition du projet Apache OpenOffice.



### Licence de OpenOffice.org

Licence LGPL, on peut donc utiliser le code source dans notre propre logiciel, même propriétaire sans devoir fournir le code de notre logiciel, mais si on modifie le code sous LGPL, on doit rendre disponible la version du code modifié sous LGPL.

### Business model

Sun a rendu le code source de StarOffice disponible sous LGPL, afin de pouvoir construire les versions suivantes de StarOffice sur base de OpenOffice.org. Le business model consistait donc a proposer un logiciel propriétaire basé sur le logiciel open source avec des modules complémentaires dans le logiciel propriétaire et accompagné d'un support.

## LibreOffice

* Projet le plus actif.
* Sountenu par la FSF.
* But : diffuser une suite bureautique indépendante de toute société.
* Communauté = ancienne communauté de OpenOffice.org.
* LibreOffice utilisé par de nombreux organismes publique, notamment l'Etat français.
* Propose à Oracle de les rejoindre, mais Oracle refuse.

### Licence de LibreOffice

Mozilla Public License 2.0. => Si modification du code sous MPL, on doit rendre le code modifié publique sous MPL mais pas le reste. MPL peut être utilisé dans un logiciel propriétaire.

### Business model

* LibreOffice est géré par The Document Founation, ils fonctionnent avec les dons. 
* Des entreprises de services viennent se greffer autour du projet LibreOffice pour proposer un support et d'autres types de services aux professionnels. LibreOffice émet des certificats pour garantir que ce sont des gens compétents.

## Apache OpenOffice

* À l'arrêt depuis 2014.
* En fin de vie.
* Release annuelle, mais plus grand chose de fait concrètement.
* Faille de sécurité.
* Téléchargements restent important par manque de connaissance de certains utilisateurs.
* Apache admet qu'ils manquent de contributeurs, mais ne veut pas stopper le projet.


### Licence

Apache License 2.0. Free to use, distribute, modify.

### Business model

* Essentiellemet basé sur les dons.