# Open Source Contribution Project

***Author :*** Fabian Puche

***NOMA :*** 44421900

***Academic year :*** 2020-2021

***Open-source project :*** [ServerSync](https://github.com/superzanti/ServerSync)

## Research and Selection of the Project

ServerSync is a utility for easy mod management that I used with friends not long ago when we wanted to play with each other on a server. We used it because we all had to install some mods to play on the server and this is not really straightforward for people who are not familiar with the installation of mods in general.

The thing is that the tool was working fine but it had some troubles, according to me. Especially the UI but also for some features that will be explained later.

To contribute to this project I joined it via [Loïc Laderrière](https://github.com/Hadyark) who is one of the friends that I use the application with and is also at this course. Then I decided to help because they were a lot of things to change on this project.

## Communication

Good to know is that the project was created by [Superzanti]("https://github.com/superzanti") and is now almost only managed by [Rheimus]("https://github.com/rheimus"). According to the communication for the project, I didn't communicate directly with [Rheimus]("https://github.com/rheimus") who is the main collaborator in this project but I communicated indirectly via Miro which is an online collaborative whiteboard platform which allows representing expectations precisely and clearly. The things I had to do are represented in the image below.

<img src="https://github.com/Hadyark/lingi2401/blob/master/images/Lo%C3%AFc-Laderri%C3%A8re/Capture7.PNG" width="800">

## Collaboration for the Project and Summary of Contribution

For this project I collaborated with [Loïc Laderrière](https://github.com/Hadyark). We helped each other when needed but we were both working on different things. As said before the project needed a lot of changes that was a bit too much for only one person. Below you can see a summary of all these changes.

UI improvements :

* UI from Swing to JavaFX - [@hadyark](https://github.com/Hadyark)
* Menu to navigate through the application - [@hadyark](https://github.com/Hadyark)
* Table to display all the mods and their status - [@hadyark](https://github.com/Hadyark)
* Log panel has been separated from the other panels - [@hadyark](https://github.com/Hadyark)
* Panel to modify the options - [@hadyark](https://github.com/Hadyark)
* Custom themes - [@hadyark](https://github.com/Hadyark)
* Progress bar changes according to the overall progress and not according to the individual progress of the files - [@FabianPuche](https://github.com/FabianPuche)
* Information about the progression during the update - [@FabianPuche](https://github.com/FabianPuche)

New features:

* Save/edit option in the application - [@hadyark](https://github.com/Hadyark)
* Status of mods without forcing the update ("Up to date", "Missing", "Outdated") - [@FabianPuche](https://github.com/FabianPuche)

## My Contribution for the Project

Before contributing to this project, you could not check if your list of mods were up to date. You couldn't because the tool only download all the mobs and put them in your folder. It's not really practice and gainful because the server could just update files that are outdated instead of downloading all of them. On the one hand, it would take less time for the user and, on the other hand, it would use less bandwidth for the server. Now you can do it with the new "Check update" button. It is very useful if you're working with large amount of mods. To have an idea when we used it with friends not long ago we played with a mod pack named [RLCraft]("https://www.curseforge.com/minecraft/modpacks/rlcraft") which have a weight of 182 Mo. 

With the new "Check Update" button, you can now also have information about each mod ("Up to date", "Missing", "Outdated"). 

Finally, when downloading you now have a progress bar to keep track on downloaded files and files that still need to be downloaded.

<img src="https://github.com/Hadyark/lingi2401/blob/master/images/Lo%C3%AFc-Laderri%C3%A8re/NewUI1.PNG" width="800">


