# Open Source Contribution Project
*Author :* Julien Lamon

*Date :* September-December 2020  
*NOMA :* 0806-20-00

## Research and Selection of the Project

As I participated in the implementation of an Open Source Project from April to July 2020, I wanted to contribute to a project that was in the same languages as that specific project. The languages being *Typescript* and the Javascript Framework *Vue.js*. 

I therefore began to start searching for Open Source projects around these languages. I used the [good first issue website](https://goodfirstissue.dev/) in order to find projects and I found these two: [Vuesax](https://github.com/lusaxweb/vuesax), and [Vuestic-admin](https://github.com/epicmaxco/vuestic-admin). Since I already worked with Vuesax on a project I started to look into its repository. However, after some time searching, I found out that these two projects are too big for me. By that I mean that I was not finding any issue in which my help would be benefic: I would mostly have wasted the time of the projects' maintainers.

I then moved myself to GitHub's project selection that are being great for new contributors ([here](https://github.com/showcases/great-for-new-contributors)). On this selection I found Exercism. It really interested me since I followed a course last year called "Concepts of Programming Languages" being about the implementation of a programming language (being LISP). It then followed with the will to create a new programming language with some of my friends. It was then a good opportunity for me to teach concepts of programming languages to others.

## Exercism

Exercism is a not-for-profit organisation providing exercises to around 40 languages. It provide explanations to concepts, and then exercises to practice those concepts. It also offers human mentoring in addition with automated mentoring.

As I saw that they are implementing the third major interation of Exercism, I chose to help in the implementation of exercises.

## Contribution to the project

### 28/10

After my choice to implement new exercises, I had to choose the language in which I will cooperate. I first choose Java since it is the language in which I have the most experience, but all issues were already assigned. I then wanted to help in TypeScript or Scala, but found out that they are not requesting for contribution in these languages yet. I then finally moved to JavaScript and chose an issue that can be found [here](https://github.com/exercism/v3/issues/1883).

### 30/10 - 4/11

During this time I've been reading all documents needed to properly write concept documents. In short, I had to write content for these files:
- `introduction.md`: introduction to the nullability concept in Javascript.
- `instructions.md`: instructions on the exercise about Nullability.
- `hints.md`: hints if the student is stuck on the exercise.
- `after.md`: more information on nullability in Javascript.

After redacting the files, I created a [pull request](https://github.com/exercism/v3/pull/2697), and I am now waiting for a review.

### 07/11

The pull request has just been reviewed. Since it is textual, I will need 3 reviews. However, the comments are not complex, it was mostly about restructuring sentences, or refactoring some files.
- The docs needed to be read became obselete at the time I was implementing it. A reviewer then told me what was the new structure all about, and I changed it considering his comments.

## 01/12

Up to this day, two reviewers already reveiwed the pull request. I am still waiting for the last 24 days that the last reviewer comes as well...

## 30/12

After almost two months of waiting, the merge request finally got approved !

## Conclusion

After working on this (relatively small) issue, I started to get really interested in this project. Therefore, as I said earlier in the report, I could not work on Scala since they were still not requesting for contribution. I then think that I will be helping them as soon as they ask for any contribution.

I might even ask to be a maintainer for Scala, but I am a bit doubtful on my lack of experience in Scala to become one.

## Post Scriptum

After finding Exercism, I saw that a [student](https://github.com/ploum/lingi2401/blob/master/projects/projects_2020-21/Report-Emilyen-Laffineur-68561900.md) also gave a contribution to Exercism. His issue therefore helped me on how to link an issue to a Pull Request. 