# Open Source Contribution Project

**Author:** Matthieu Leclercq

**NOMA:** 10851600

**Open Source Project:** [Pokeapi](https://github.com/PokeAPI/pokeapi)

**Academic year:** 2020-2021


## Disclaimer

This project is talking about the game *Pokemon* and I will suppose that every one know the basic idea of pokemon but it's not mandatory to understand my participation. At least, you must know that a pokemon is a sort of a creature that you can train so it will evolve into something else. Some of these pokemons can evolve into one or into another one depending of the context (actual time, location in game, happyness,...). It's the case of eevee (c.f. the image bellow) which is the center of the project

<div style="text-align:center"><img src="https://img.rankedboost.com/wp-content/uploads/2016/07/Eevee-Evolutions-Pokemon-GO.png" /></div>
     
## What is PokeAPI?

PokeAPI is an open source project based on the very popular game *Pokemon*. It is more precisely a big database wich contain every information about every Pokemon like their power, their sprites, how many experience they need, in which pokemon they will evolve to, at what condition, etc. Pokemon is a very complex game if you dive deep in it and there is a lot of data that are usefull (and mandatory) if you want to create something around the game. All these data are reachable via some HTTP requests and are sent throught JSON files.

## Why did I choose PokeAPI?

Since we where confined, I created a discord bot with a friend for fun that allow users to catch, evolve, trade and manage pokemon and we needed a database so we used this PokeAPI. This open source project was very helpfull and had everything we needed so when I learned that I had to participate into an open source project, my choice was very fast.

## What what was my contribution?

While we used our bot a lot, we noticed some errors (most of time, it was obviously our fault) but one time, we noticed that a pokemon *(eevee for the curious)* doesn't evolve as he was suppose to. This is a particular pokemon that have a lot of differents evolutions depending on the circumstances and he always evolve into the same one (which is not suppose to happen). So I investigated and I noticed that the JSON that was sended by PokeAPI had an error, a list of null that was not supposed to be there, so I hot fixed it but it was not realy great.

Thus, I investigated inside their github repository and find out that there were using python scripts that convert *CSV* into a json and sent it. By regarding into these *CSV* I founded four empty lines that shouldn't be there so I decided to modify it and send these modifications. After some talk with the manager of the repository (c.f. [next section](#communication-with-the-community)) I updated my modifications because 2 of theses lines shouldn't be deleted  and the 2 other should be modified to described the evolution *(again for the curious, it has no mention about a leaf stone for leafeon and neither about the Ice stone for Glaceon)*.

## Communication with the community

When I did my first pull request, I was a bit to quick and I just deleted every empty line that I founded (4 in total). The manager of the community kindly explain to me that we can't remove 4 lines just like that because all id's after thoses lines should be modified too and he also explained that 2 of thoses 4 lines were ok. After some days, he reviewed what I was trying to do and admit that two of theses 4 lines were indeed a mistake so he asked me to update my pull request following his instructions. I did it and then he validated my [participation](https://github.com/PokeAPI/pokeapi/pull/541).

Some time after his merge, I also have been notified that he updated another [repository](https://github.com/PokeAPI/api-data) which is a static copy of the JSON files that were generated by his python script. By this [updating](https://github.com/PokeAPI/api-data/commit/f1489ced8127e2c1407b81a808d62fdc85298aac) he regenerated his data so the HTTP request send now the correct information about the evolution.

## What I learned?

My participation was very tiny (2 lines in a CSV file, everyone can do it) but I saw how greatfull was the manager and I also saw the kindness of the community. Of course it was short but it's only by using an open source project that we can find some error like this and the participation of the community is mandatory to step up on the project. 

I also learned to be more strict about myself when I'm looking for something because if the manager accept my pull request as it was at the begining, I would destroy two evolutions AND without solving the initial issue.

So, last but not least, now it works, the issue is repear, the new data has already been deployed and I can remove my hot fix in my code (which was terrible!), you can have and idea by looking the code I deleted here:

```
if(user.currentPokemon.name === "eevee" && user.currentPokemon.triggerEvolution === null){
    return false;
}
```