# Open Source Contribution Project
*Author :* Loïc Laderrière

*Date :* 2020

*NOMA :* 44261900

*Selected project :* [ServerSync](https://github.com/superzanti/ServerSync)

*Pull request :* https://github.com/superzanti/ServerSync/pull/223
## ServerSync
ServerSync is intended to make it easier for beginners to connect to a modified Minecraft server by automating certain tasks. It will sync all files and make any necessary changes for the user to join the server. (A player must have the same modifications as the server to be able to connect to it)

It is currently developed by one person (Created by [@superzanti](https://github.com/superzanti) and taken over by [@rheimus](https://github.com/rheimus)) it has +30,000 downloads on its [CurseForge page](https://www.curseforge.com/minecraft/mc-mods/serversync)

### Project Selection
It was obvious for me to choose this project because I use it personally.
I find that this one has a great potential but that the lack of functionalities and its too rudimentary interface fail it. Having already thought about working on it in my spare time, it's a pleasure to be able to do this as part of a course to try to make it more popular in the Minecraft community.

### Communication
I contacted [@rheimus](https://github.com/rheimus) by email to find out if he was interested in the complete GUI change and if so, did he agree to switch from Swing at JavaFx. I told myself that if a redesign had to be done, I might as well take the opportunity to change the librairy.

You should know that JavaFX is considered the successor to Swing because it has more support and features and that Swing will no longer be maintained by Oracle from 2026.

He suggested that I use [Miro](https://miro.com/), an online whiteboard, to discuss the project.
I started by showing him a prototype and then for each major modification, he gave me his opinion and guided me towards a design that he liked.

| <img src="https://github.com/Hadyark/lingi2401/blob/master/images/Lo%C3%AFc-Laderri%C3%A8re/Capture.PNG" width="480"> | <img src="https://github.com/Hadyark/lingi2401/blob/master/images/Lo%C3%AFc-Laderri%C3%A8re/Capture2.PNG" width="480"> | <img src="https://github.com/Hadyark/lingi2401/blob/master/images/Lo%C3%AFc-Laderri%C3%A8re/Capture3.PNG" width="480"> |
|:---:|:---:|:---:|
| <img src="https://github.com/Hadyark/lingi2401/blob/master/images/Lo%C3%AFc-Laderri%C3%A8re/Capture4.PNG" width="480"> | <img src="https://github.com/Hadyark/lingi2401/blob/master/images/Lo%C3%AFc-Laderri%C3%A8re/Capture5.PNG" width="480"> | <img src="https://github.com/Hadyark/lingi2401/blob/master/images/Lo%C3%AFc-Laderri%C3%A8re/Capture6.PNG" width="480"> |
| <img src="https://github.com/Hadyark/lingi2401/blob/master/images/Lo%C3%AFc-Laderri%C3%A8re/Capture7.PNG" width="480"> |
### Collaboration
I collaborated with [@FabianPuche](https://github.com/FabianPuche), one of the friends that I use this app with. So we divided the tasks. Each having implemented features as well as on its interfaces.

We helped each other to understand the code to integrate our codes together but each one has coded its features.

### Contribution
I continued to respect the main goals of ServerSync are:

- Small, ideally we don’t use libraries unless it would be unreasonable not to or it would provide a much worse experience

- Simple, whatever ServerSync does it should be usable by less technical users (difficult to achieve but a worthy goal)

The main objective of the redesign was to make it more "user-friendly" by changing the design too rudimentary for the "material design", by adding more information (list of mods, are they up to date or outdated ?, ...) and adding some features like the ability to change and save the app options. Previously, the user had to manually access modifier options files.
Make it more "maintainable" by switching to JavaFX and adding a navigation bar that will make it easier to add elements to the user interface.

The GUI has been improved: 

- Switch GUI widget toolkit (~~Swing~~ -> JavaFX) [@hadyark](https://github.com/hadyark)

- Add of a menu to navigate through the application [@hadyark](https://github.com/hadyark)

- Add a table to display every mods and their status [@hadyark](https://github.com/hadyark)

- The log panel has been separated from the other panels [@hadyark](https://github.com/hadyark)

- Add of a panel to modify the options [@hadyark](https://github.com/hadyark)

- Add custom themes [@hadyark](https://github.com/hadyark)

- The progress bar changes according to the overall progress and not according to the individual progress of the files [@FabianPuche](https://github.com/FabianPuche)

- Improve information about the progression during the update [@FabianPuche](https://github.com/FabianPuche)

New features:

- Can save and edit options in the application [@hadyark](https://github.com/hadyark)

- Can check the status of mods without forcing the update ("Up to date", "Missing", "Outdated") [@FabianPuche](https://github.com/FabianPuche)

### Old UI
<img src="https://github.com/Hadyark/lingi2401/blob/master/images/Lo%C3%AFc-Laderri%C3%A8re/OldUI.PNG" width="480">

### New UI
| <img src="https://github.com/Hadyark/lingi2401/blob/master/images/Lo%C3%AFc-Laderri%C3%A8re/NewUI1.PNG" width="480"> | <img src="https://github.com/Hadyark/lingi2401/blob/master/images/Lo%C3%AFc-Laderri%C3%A8re/NewUI2.PNG" width="480"> | <img src="https://github.com/Hadyark/lingi2401/blob/master/images/Lo%C3%AFc-Laderri%C3%A8re/NewUI3.PNG" width="480"> |
|:---:|:---:|:---:|

# Examen

## Vie privée
### Pourquoi ce sujet?
- Car c'est un sujet important et d'actualité
- Je m'y intéresse beaucoup depuis qu'on en a parlé en cours et je voulais faire un complément à ce que vous aviez dit au cours (il y a surement des choses qui ont été dites en cours, je m'en excuse déjà si je les répète, mais comme je lis des articles sur ce sujet depuis plusieurs je fais plus la distinction entre ce qui a été dit et ce que j'ai lu)

Toujours eu conscience que la collecte de données et la surveillance de masse existaient, mais je ne m'y étais jamais vraiment intéressé et j'ai toujours dédramatisé cela en me disant que c'était utile. (Pour contrer le côté sombre d'Internet: pédocriminalité, trafic illégal, attentat) et, car ça me semblait utile (Pub personnalisé).

Mais je commence à me rendre compte que si je devais mettre le pour et le contre dans une balance. Le contre l'emporterait largement, car il y a beaucoup trop de dérives.

Les données personnelles sont la nouvelle ruée vers l'or.
GAFAM devient de plus en plus puissante (PIB plus élevé que la plupart des pays dans le monde)

Abuse de leur pouvoir et de leur position dominante, se permettent de ne pas respecter les lois.
Ex: Rachat d'entreprises pour les tuer

Désinformations ?
Récemment Apple, dans le but de protéger ses utilisateurs a ajouté une fonctionnalité à sa dernière version d'IOS qui rend plus difficile le ciblage publicitaire en empêchant par exemple qu'une app puisse pister l'utilisateur à travers plusieurs applications (l'utilisateur devra donner son accord). Facebook n'a pas apprécié et accuse Apple « d'avoir un impact nuisible sur de nombreuses petites entreprises qui luttent pour se maintenir à flot et sur l’Internet libre, sur lequel nous comptons tous plus que jamais » et va jusqu'à acheter des pages dans de grands journaux pour diffuser cette information. 

Leur gestion est beaucoup trop floue et manque d'honnête. Ça se voit dans une autre polémique. Facebook s'était engagé à ne pas fusionner ses données avec celle de Whatsapp et qui se retrouver à menacer les utilisateurs de fermer leur compte s'il n'accepte pas.

Whatsapp réagit avec ce qui ressemble à un communiqué de crise pour dire que jamais ils ne liront les messages privés (à l'exception de ceux des comptes entreprises)

Sauf qu'à aucun moment il ne parle des métadonnées chose qui est inconnu pour la plupart des utilisateurs ce qui est pour moi un manque de bonne foi.
C'est dur de le faire confiance alors qu'ils enchainent les failles de sécurités et qu'ils changent d'avis sur beaucoup de choses

(Ce qui a poussé les utilisateurs vers d'autres services comme Telegram ou signal)

Les gouvernements aussi abusent de la collecte de données 
- Censure en Chine
- USA qui ferme des sociétés si elles refusent de coopérer (Lavabit/Snowden)

### Les solutions possibles
Sensibiliser surtout les plus jeunes, car se sont les plus actifs sur Internet donc les plus touchés (comme pour un cours sur la sexualité ou l'éthique)

- Données qu'on laisse échapper consciencieusement:
    - Messages privés
    - Relation (Like Facebook)

- Données qu'on ne soupçonne pas:
    - Metadata (lieu, heure, appareil/logiciel utilisé...)
        - Les photos sur Facebook
        - Messages chiffrés sur Whatsapp mais pas le reste
    - Notre navigateur permet de nous identifier

Utiliser l'open source, car souvent n'a pas de but lucratif et est soutenu par des bénévoles. 

- Que ce soit pour remplacer un service
    - F-Droid: Market alternatif à Google play store qui n'utilise que des projets open source qui sont compilés par leur soin
    - Signal: Messagerie chiffrée n'ayant pas pour but de gagner de l'argent

    Pour revenir à la sensibilisation beaucoup de gens quitte Whatsapp pour Telegram ce qui n'est pas forcement une bonne chose, car:
    Telegram se veut sécuriser, mais n'a pas le chiffrement activé par défaut
    L'entreprise cherche à se faire de l'argent (ça pourrait dégénérer comme whatsapp) sachant qu'ils s'étaient engagés à ne pas mettre de pub dans leur app sauf que maintenant ils envisagent de le faire (justifier par l'arrivée massive d'utilisateur et le cout des serveurs) qui sait quels autres engagements ils ne respecteront pas

- Ou pour "contourner" un service dans le but de continuer à l'utiliser, mais de manière plus privée ou anonyme:
    - Aurora store: Market permettant d'accéder au Google play store sans compte et donc anonymement (permets de simuler un autre téléphone/pays/langue)
    - Freetube: Logiciel qui permet d'utiliser YouTube, tout en ayant ses données sauvegardées en local (abonnements, historiques)
    - Application de type "container": Frost for Facebook ou Barinsta (Instagram)
    - Cryptomator pour chiffrer les données se trouvant sur un cloud

- Le décentralisé qui permet de ne pas laisser nos données à une entreprise
    - Mastodon - Twitter Alternative 
    - Friendica - Facebook Alternative 
    - PeerTube - Youtube Alternative

    - Problème:
        - Personnellement je ne suis pas sur de la sécurité, car j'ai la sensation qu'on donne nos données à n'importe (mais c'est surement parce que je ne m'y connais pas assez bien)
        - Si y pas de contenu y a pas d'intérêt (ex: les vidéastes sont sur YouTube et non sur Peertube)

- Choisir une société en fonction du pays dans lequel elle se situe
("Fun fact" comme expliqué dans l'intro, les données privées sont la nouvelle ruée vers l'or, et je trouvais ça amusant que la suisse qui s'est vu longtemps considéré comme un paradis fiscal, se retrouve maintenant favoris pour héberger cette nouvelle "richesse". Sachant qu'en 1987 la CIA et l'Allemagne possédaient une agence de crypto en Suisse et vendu des produits pour ensuite facilement déchiffré les messages, mais je doute que ça se reproduise maintenant avec les lois qu'ils ont)

- Heberger nous-mêmes nos données
    - Nextcloud permet d'avoir son propre cloud
    - Problèmes: 
        Couteux et pas forcement sécurisé, car pas à la portée de tout le monde

Pour moi les meilleures solutions:
- C'est choisir de se passer d'un mauvais service quand on le peut (si ça ne gêne pas) (ex: mail/calendrier/moteur de recherche -> pas dérangeant, car pas de conflit avec d'autres utilisateurs)
- Continuer à utiliser nos services tout en se protégeant (freetube, cryptomator,...)

### Conclusion
C'est un sujet très intéressant qui mériterait clairement d'en parler plus souvent surtout dans les écoles et que ne se soit pas uniquement un cours réservé au MASTER INFO/INGé. Sans trop entrer dans les détails, car c'est un sujet trop complexe pour que ce soit à la portée de tout le monde, mais en expliquant au moins pourquoi c'est important, les conséquences et les dérives que ça peut avoir ainsi que différentes solutions pour se protéger.

