# Open source strategy project
---
***Author***: Pierre-Rodéric Roose\
***NOMA***: 6007-15-00\
***Project***: [Exercism v3](https://github.com/exercism/v3)\
***PR link***: https://github.com/exercism/v3/pull/2914

---

## Research of the project
My main problem was to find the project to contribute to. As the instructions for the project said that the contribution didn't have to be technical, I took my time to find it. But, even though the teacher warned about the time needed for a pull request to be accepted, I took way too much time to begin a project.

### Atom
At first, as an Atom user myself, I went to [Atom's Github](https://github.com/atom/atom) to see if there was some easy contribution I could do. Following [Atom's guidelines](https://github.com/atom/atom/blob/master/CONTRIBUTING.md#how-can-i-contribute) for first contributions, I looked at the issues with the "beginner" and "help-wanted" tags. I only found old issues (from 2013 and 2015). Looking more into some of them, it seemed a bit confusing, as, apparently, some contribution was already given, or the Atom's team decided to implement another solution, but the issues was not closed. I decided to find a project where the issues were easier to discern.

### Mailspring
[Mailspring](https://getmailspring.com/) is a free email client for Mac, Linux and Windows. I use it on Linux, and, knowing it was [open source](https://github.com/Foundry376/Mailspring), I went and searched for an issue I could help with. The recommended tag "help-wanted" gave no results. I had a possible enhancement to make to the app, and wondered if I could create an issue and resolve it directly, but the ["Where to contribute"](https://github.com/Foundry376/Mailspring/blob/master/CONTRIBUTING.md#where-to-contribute) section of their github let it appear that there was only a low chance they would accept it.

### ScpToolkit
[ScpToolkit](https://github.com/nefarius/ScpToolkit) is a software that can take a PS3 or PS4 controller as input and simulate it as a Xbox controller for the PC. I personally use it a lot in order to use my PS3 controller for my PC games. I already thought of an issue, even before looking at the source code: prevent my controller (connected to the PC) from connecting via bluetooth to the PS3 in another room, and altering the film my family is watching thanks to the PS3. Unfortunately, the README file displays an "Obsolescence notice" and states that the support is discontinued.

### Exercism
At this point, I am very late. I have a week to find a project, contribute, and have my PR accepted. I tried to find an open source project for an app that I use, but I don't have more time, so I start looking at the work done by students of the previous years, and find some contribution to Exercism. I then look in Github, and find some easy "help-wanted" issues in the third major iteration of Exercism: Exercism v3. Finally, some hope for me!

## The contribution
The [issue](https://github.com/exercism/v3/issues/923) was about creating a list of concepts that must be understood in order to correctly make a binary-search, in C. The concept were to be extracted from the existing binary-search exercise from Exercism. It didn't require to code anything, just to write a file containing the concepts, links to explanations of these concepts, and explanations to why these concepts are needed. I first looked at existing files of that type, made for other exercise, to keep the same format, style, and links, in the case of a similar concept. For some links in other files, though, I noted that it would point to external links ([c manual from gnu.org](https://www.gnu.org/software/gnu-c-manual/gnu-c-manual.html#The-return-Statement)), instead of existing files in the Exercism Github. I commented on the issue to know what the best procedure was, but as I was very late, and didn't receive any response for several days, I kept the "external links", because they already were accepted in other works. After I submitted the work, all the 7 automated checks passed successfully. Just one approving review is now required for my PR to be accepted.

## Goal of the course project
If I remember the first classes correctly, the teacher said an important goal of the project was to help us get into the "open source world", and interact with another community. For my part, that goal is reached: I'm pleased to have contributed to an open-source project (even though my contribution wasn't accepted yet), and I'm now eager to help other projects that are more related to me/what I use. It helped me realize that contributing was actually not that hard.


# Presentation plan (exam): Kali Linux

## Introduction
* Why I chose to present Kali Linux.
* Link to my security class.

## Main presentation of Kali Linux
* General history of Kali Linux.
* License used.
* Will from the developer to use open-source tools.
* Respect standards (avoid problems such as the "Outlook winmail.dat" case).

## Business model
* Totally free, for ever.
* Funded (and developed and maintained) by Offensive Security (or Infosec/Offsec).
* Quick presentation of Offensive Security and their business model.

## Community
* Dictatorship ? : only a small developer team able to commit.
* Dictatorship is good to avoid error: security is a complicated field.
* But open to community: bugtracking, IRC channel, everyone can modify anything about the Linux distribution on their own.
* Very good documentation.
