# Open Source Contribution Project

*Author:* Adrien Moinnet

*NOMA:* 70571500

*Year:* 2021-2022

*Selected project:* [LeagueStats](https://github.com/vkaelin/LeagueStats)

*License:* ShareAlike 4.0

# Chapter 1 - Finding a project

For the realization of this work, I first had to choose a theme, an interesting project, not too simple but not too difficult either.
In order to find the perfect project for this course, I decided to search on github by putting keywords related to my passions or projects that interested me. So I started to put "chess" or "3D LeapMotion" (since I'm going to use it for my dissertation, it could have been a good idea). 
But unfortunately, either people didn't respond to my requests, or the projects were a bit too complex, or they were almost finished.
Therefore, I started to look for another topic including "League Of Legends" (a video game I played a lot and still play occasionally). I was able to find many codes related to bots to cheat or codes in Chinese or Korean.

# Chapter 2 - Project selection

After searching for a long time, I managed to find the rare pearl. A project that uses interesting applications for future projects (Vue, Javascript, Typescript, Nodejs, PostgreSQL, Redis, etc), an active project, a project based on an effective website and therefore, very often used by users, a relatively young and dynamic community and finally, a discord community to be able to discuss with the different developers of the project.
This project is called LeagueStats. It is a website based on the game "League Of Legends" and allows players to analyse their game data and obtain certain statistics about their games that are not available directly in the game (https://leaguestats.gg/).

# Chapter 3 - Launching the project

In order to be able to launch the project on his computer, I could follow the description of the project which was relatively well done. Therefore, I had to install some frameworks such as PostgreSQL and Redis, and then come the problems. I had a lot of trouble getting the project to work. I started to run the client code and the server code at the same time in order to test it. Unfortunately, I couldn't understand my mistakes very well. I had to create a PostgreSQL user, figure out how to get the APP_KEY and finally the RIOT_API_KEY. After having the help of a developer and the help of the project creator, I finally managed to launch the project.


# Chapter 4 - Looking for features to add or improve

In order to be able to contribute to the project, I obviously had to understand how the code works, read it in its entirety and look for features to add or improve.
After reading, I was able to make a small list of features to improve, such as : 
    • Creating a button to display 50 old matches (instead of having to press the 10 button 5 times)
    • Improving the site by allowing to see the stats of the players of the previous years (for the moment, only the year 2021 is taken into account)
    • To be able to display the data concerning the 5vs5 ranked matches
    • Improve the display of the most played characters by activating the "only most played" button and by allowing to display more data concerning the games by inserting as for the main menu of the player
    • Etc ...

As you can see, there are still a lot of features to add and improve on the site even if it is already quite complete for the moment.

# Chapter 5 - Choosing the feature to improve

To be honest, I didn't really have time to work a lot on the improvement of the site. All the steps already took me a lot of time, so I had to choose a feature that was not too difficult to implement and that did not require weeks of work. Therefore, I decided to implement a button to display more than 50 matches instead of 10 to allow players to see their match stats more quickly. I thought this was an important feature as it was causing a lot of problems in using the site.

# Chapter 6 - Pull request

After modifying two files and testing and verifying the functionality of my implementation, I made a pull request so that my functionality could be introduced into the original code. I haven't received a response yet but having spoken to the project creator, there is a good chance that it will be accepted.
