# Open Source Contribution Project

| **Author:**              | *Andrew Arnita*                                     |
| ------------------------ | --------------------------------------------------- |
| **Date:**                | 18/09/21                                            |
| **NOMA:**                | 0488-21-00                                          |
| **Academic Year:**       | 2021-2022                                           |
| **Open Source Project:** | [Meshery.io](https://github.com/meshery/meshery.io) |
| **Lisence:**             | [Apache 2.0](https://github.com/meshery/meshery/blob/master/LICENSE)                                                                         |


# The Project: Meshery
I guess you may be wondering and asking yourself, what is Meshery? Right? Well, I won't be wasting your time 
here to let you go and understand it yourself, I did that or you :). Meshery as defined on their website 
[mesheri.io](https://docs.meshery.io/project) is, "Meshery enables operators to deploy WebAssembly filters to 
Envoy-based data planes.", so yes that's basically it, but wait, did you really understood that phrase? Yes?, 
No...? Well let me explain it in Layman's terms it would be mush easier for you, but for me.. Hmm, not quite 
easy. After doing some research about this company, I realized how organized their platform is, how did I know? 
Please, take a look at their github repos [Meshery](https://github.com/meshery), that's only the public ones, 
maybe they're hiding in their private world much more repos than that! Let me simplify it for you and make you 
understand a little bit more about what is a service mesh that Meshery has been built upon. Service Mesh, is a 
method to enable application parts that are not related to each other to be able to communicate. It's like an 
infrastructure layer that helps service-to-service communicate wisely over a network. A service mesh is a 
configurable infrastructure layer for micro services application, it provides micro services governance by 
adding necessary visibility and security controls when you have dozens of services. The service mesh helps 
discover, authorize, and track the different service instances you have.




# Meshery.io
Meshery.io? Wait, isn't it the same as the above Meshery but with a ".io" decoration at the end? Well... Not 
really. Meshery.io is the website that the Meshery use to describe and attract users who want to use their 
service, that's why we see the .io at the end, so I would advise to just take a look at how beautiful and 
organized their website is at [Meshery.io](https://meshery.io). Now that you made your eyes a little more 
comfortable while looking at their website, I would like to explain why I chose to work on this project, but 
not in here, but in the paragraph below. Yeah sorry for making you scroll some pixels down :)




# The Project I Worked on
After doing some research on github and after many failed attempts to contribute in big projects such as NodeJs 
and Angular, since I like to work with these frameworks, it was a little too advanced/big for me as a 
contributing beginner, this is why I decided to keep on digging until I find a project that suits my knowledge 
and I would be able to contribute in and fix issues that developers didn't fix or don't have the time to, well 
this is what the "Issues" Tab on github is for right? After using github's advanced search engine, I came up 
with a search that would help me identify why I am looking for, this search was: "is:open label:'good first 
issue' language:HTML is:public", mutliple repos came up with multiple projects, but after checking some of them 
I realized that some projects are too small to contribute in, or project owners are not willing or active to 
see PR that might fixe their issues. This is when I came across Meshery.io, a beautiful and advanced website 
that fits my needs and that has a community that you can be part of and that helps you on your way if you faced 
any difficulties while working on their fixes. The fix that I am worked on is in the [Issue paragraph](#Issue) 
down below.




# My Motivation
Since I am passionate about the web development world, I am always excited to start working on personal 
projects or projects that enrich my knowledge in web development. Since contribution in projects is a really 
good way to be part of a development community, I decided to take LINFO2401 and start learning about the 
contribution world that every passionate developer should be envolved in, know how it works, and what are the 
tools needed to be able to contribute in a practical and professional way.




# Issue
I worked on [Issue #562](https://github.com/meshery/meshery.io/issues/562) on the Meshery.io project. As I 
have experience in the web development world after working on many websites in the past, I was able to read 
their code and understand why the issue exists in the first place, so the issue was that they used different 
class names in different orders, and a class name was missing in the <a></a> tag in the "Read More" button. 
After forking their repo and reading all of their [contributing documentation](https://github.com/meshery/meshery/blob/master/CONTRIBUTING-gitflow.md), I was able to build and run my code locally as described in their 
documentation, this helped me understand how their code is structured and change things locally so I won't mess 
with their original website. After spending some time understanding their code and finding where I need to 
change things, I was able to identify the problem and was able to fix it since I understood where the problem 
resided. I would like to share more on how I was able to contribute and the community that I worked with at a 
later stage :).



# Contribution
After choosing the projects and checking if there is any community I can be able to talk to or contribute in, I 
decided to take a chance and try to fix the Issue discussed earlier. After reading Meshery's contributing 
documentation I was able to find a google form which I had to fill before getting access to a Slack community 
group that all developers talk on with multiple sections devided for each part of the Meshery project. Filling 
up the Google form and then joining a big Slack community was something new for me and felt like I belong in 
their community. So I introduced myself in the #newcomers sections and everyone was very welcoming and ready to 
help me. Mr. Lee Calcote is the CEO of the company and after checking his Github repos and contributions and 
knew that I will be guided by a professional person. I sent him a private message to talk a little bit about 
what I will be fixing and what are the required tools needed to run the project, he answered quickly and help me find my way to fix the issue.



# Pull Request: Successfully Merged!
As I mentioned earlier in the Issue paragraph, I discussed what issue has to be fixed and how I was able to 
find the problem and understand the code in order to fix it. Basically, this is what I did :). I fixed the 
issue, test it, and run some github commands to be able to have a professional PR in their project, some commads used are: ([commit signoff](https://docs.github.com/en/authentication/managing-commit-signature-verification/signing-commits), fork my own repo, [fetch upstream](https://docs.github.com/en/github/collaborating-with-pull-requests/working-with-forks/merging-an-upstream-repository-into-your-fork), [git rebase](https://docs.github.com/en/get-started/using-git/about-git-rebase)...). After finishing all the steps needed to make 
a PR, the only thing I had to is wait. This is what I did, everytime I go and check if any reviewers checked my 
PR for some feedback, after a while, I receive an email saying that a reviewer approved my commit with a 
positive message: "LGTM🎉, Thanks @AndrewArnita". Now, the only I had to do is wait for Mr. Lee Calcote to 
review my commit, approve, and merge it with the original project. So, this what happened :). Mr. Calcote 
approved my PR and merge it with his original project, and the site went live with a fixed issue this time! 
This was his feedback: "Good stuff, @AndrewArnita 👍", "Thanks for your contribution to the Layer5 community! 
🎉".

## Please check the fix that I did [here](https://github.com/meshery/meshery.io/pull/564).