# Open Source Contribution Project
*Author* : Cyrille Debongnie

*Date* : Novembre 2021

*NOMA* : 92461200

*Selected project*: Exercism

# Research and Selection of the Project
First ever dive into the open-source world, the amount of possibilities was as exciting as overwhelming. What to choose? What project could be relevant?
I was considering participating in VLC since I’m using it a lot and had found a few behaviors that I wanted to improve (failing to scan the casting device, impossibility to cast subtitles). After considerations it seemed rather hard to dive into, the learning curve too steep, so I chose to focus more on a javascript-oriented project, as this is the language that I’d like to improve on more. 
I first stumbled upon [GoodFirstIssues][gfi]  where you can see a list of open issues on GitHub, which is great if you’re looking to dive directly into an issue, but lacks an overview of the community participation aspect in my opinion. 
I finally found the teaching platform [Exercism][exc] which has a beautiful GUI and a really well made contribution system, very organized. It also made a lot of sense to me to contribute to this project, because I'm teaching private classes, and it's much more fulfilling to help as many people as possible that may not afford to pay for school or private tutoring.

# Exercism 
Exercism is a web based platform providing free education on programming paradigms and concepts. They offer many interactive courses on a huge variety of languages. The open-source community is rather active and helpful.

# Process
I browsed the issues list and chose a non-technical issue : [FirstIssue][this] where I had to add explanations and informations to JavaScript concepts, such as how to use exponentiation, what is NaN, how you can use underscores for readability in big numbers and more.
I asked to be assigned to the issue and the person in charge was very responsive and very helpful. I read as much in their documentation as possible first, to avoid asking as many useless questions as possible.
In order to contribute to this project I had to install locally the fork of this project. Overall they made it very easy for beginners like me to dive in, as mentionned earlier in the few hours I looked into dozens of different projects, they had the best interface to help new contributors.

# Contribution
I was assigned two files to update, I decided to first try and get one of the file to be accepted by them before investing too much work on something that didn't fit their expectations, so I chose to update the "numbers" file, even though their website is top quality, their guidelines on how to improve concepts is rather abstract, as there is not a single right way to operate, but it's more like a mindset.
My first [PR][1PR] was denied because of a mix-up I made, I inserted the wrong snippet of code, and ended up with Java code on the JavaScript section. Here the feedback was rather short as the change request by them was solely focused on my code error and not on the rest of the work. After a quick fix, I updated my PR and awaited for the review. It also got rejected but this time I got a very thorough feedback by another contributor. 



# Conclusion
I didn't expect a few things about the open source world, how nice people could be, how exciting participating in an open-source project is, how a project cannot exist without an active community, and also how hard it can be to find an interesting issue that is not yet assigned.
Overall a very interesting experience and I'm glad to see that people are really willing to invest themselves in giving such quality education to as many as possible. 
It was rather harder than I expected to find the right level of explanations to fit their standards, as of today my contribution is not part of their project, but I'd like to keep on adjusting up until they deem it good enough, since they invested time in accompanying me, it's the least I can do.

[gfi]: https://goodfirstissues.com/
[exc]: https://exercism.org/dashboard 
[this]: https://github.com/exercism/javascript/issues/1505
[1PR]: https://github.com/exercism/javascript/pull/1534
