# Open Source Contribution Project

**Author:** NIZET Guillaume

**NOMA:** 5441-21-00

**Academic year:** 2021-2022

**Selected project**: [Files, A modern file manager for Windows](https://github.com/files-community/Files)

## Introduction

During my bachelor in computer science, I never got to contribute to an open-source project. I always thought it was super complicated and that it wasn't really worth the effort. But this year, I wanted to change my mind about this so I decided to follow this course which I saw as a good opportunity to dive into the world of open-source.

## Finding a project and a contribution

Now that I was motivated, finding the project I wanted to contribute to wasn't a big deal. I spent a few hours browsing on GitHub, trying to find a project with an active community which looked simple enough to make my first ever contribution. I focused on projects which had `good-first-issue` labels and I found an [issue](https://github.com/files-community/Files/issues/6867) on the [Files](https://github.com/files-community/Files) project which looked great for the newcomer I was: adding a keyboard shortcut to show/hide hidden files.

## Making the contribution

The very first step was building the project. It took me quite some time since it required having Visual Studio installed along with several other dependencies.

Once the project was up and running on my computer, I had to get familiar with the code to understand how everything worked, which wasn't an easy task since the project is written in C#, a programming language I had never really used.

After spending some time getting the hang of the code, I started implementing the keyboard shortcut feature which would solve the issue I had chosen. This wasn't a very hard task: a few lines of code did the job and everything was working like a charm.

I did some testing to make sure I tackled the issue correctly then I opened a [pull request](https://github.com/files-community/Files/pull/7106) to get my changes reviewed and eventually merged, maybe!

After a few hours, two conbributors approved my changes and my contribution was merged, which made me quite proud.

## Conclusion

The world of open-source is not unknown to me anymore and it is not as scary as I thought. Contributing, yet in a very small way, to an open-source project was a very pleasant experience.