# Contribution à un projet Open Source
*Auteur:* Louis Labbé

*Date:* Décembre 2021

*NOMA:* 55961700

*Projet sélectionné:* [ADE Scheduler](https://github.com/SnaKyEyeS/ADE-Scheduler) ([Issue](https://github.com/ADE-Scheduler/ADE-Scheduler/issues/651) & [Pull Request](https://github.com/ADE-Scheduler/ADE-Scheduler/pull/652))

## Recherche et sélection du projet

Aux alentours de la semaine 6 de ce quadrimestre, j'ai commencé à rechercher des projets auxquels je pourrais contribuer. J'ai tout d'abord pensé tant qu'à faire, à trouver un projet autour de mes centres d'intérêt comme les jeux vidéos, les échecs, la lecture, la sécurité, etc. Concernant les jeux, je n'ai pas trouvé satisfaction, car soit le sujet ne m'intéressait pas, soit le projet était malheureusement abandonné depuis plusieurs années. Pour les échecs, c'est tout l'inverse, beaucoup de projets sont ouverts sur le sujet, mais consistent simplement à recoder un joueur d'échecs ou le jeu en lui-même. Bien qu'intéressants, ce sont des duplicatas constants et je ne préférais pas participer à "ce mouvement" apparaissant sur GitHub. De plus, j'ai déjà codé un joueur de jeu de plateau donc l'envie m'est passée. Alors que je ne savais pas quoi faire, la solution est venue à moi toute seule. 

En effet, j'ai reçu un beau matin de S6, un mail m'indiquant qu'au moins un de mes mots de passe était compromis suite à une violation d'un site ou d'une application que j'utilise. Étant donné que je possède une armada de mots de passe très sécurisés que je prends un malin plaisir à confectionner, j'ai immédiatement regardé la liste des sites web violés récemment, mais je n'utilisais aucun d'entre eux. J'ai tout de suite envisagé de recréer des mots de passe différents ou d'utiliser un gestionnaire de mots de passe gratuit, mais il s'est avéré après quelques recherches que le mot de passe compromis était "student" pour le compte "etudiant" d'ADE pris en charge par l'UCLouvain... Après avoir un peu déstressé, j'ai réalisé que certains gestionnaires de mots de passe sont open source comme [Bitwarden](https://github.com/bitwarden). En menant une petite recherche, j'ai trouvé une [issue](https://github.com/bitwarden/web/issues/1064) abordable qui était en attente depuis plusieurs mois et j'ai commencé à inspecter le code pour résoudre le problème. Seulement comme j'étais très occupé par mes autres projets, j'ai préféré ne pas demander à m'attribuer l'issue, car je ne savais pas si j'allais pouvoir la résoudre rapidement. Et malheureusement, après 2 semaines, ce que je redoutais arriva, quelqu'un a demandé à travailler dessus après un "up" de l'auteur de l'issue.

J'ai alors entrepris de chercher un autre projet et pour cela j'ai décidé de changer de tactique. Au lieu d'en chercher un qui m'intéresse, pourquoi ne pas chercher un projet utile à mon entourage ? Il s'est révélé que bon nombre de mes camarades utilisaient ADE Scheduler. Il s’agit d’un outil qui permet de gérer à sa façon les horaires provenant d’ADE en filtrant des évènements, en améliorant leur visibilité, en permettant d’exporter le calendrier sur d’autres applications, etc. En naviguant sur le [site web](https://ade-scheduler.info.ucl.ac.be/calendar/) afin de suivre la procédure pour contribuer au projet, j'ai remarqué bon nombre de fautes d'orthographe sur différents onglets du site. Étant donné que je suis un maniaque de l'orthographe, j'avais enfin trouvé en S8 ce que j'allais faire, corriger toutes ces fautes. Comme personne dans notre année n'avait contribué au projet et que l'issue n'existait pas encore, je pouvais me laisser le temps de réaliser mes autres projets sans crainte que quelqu'un me chipe "mon issue". Finalement, il s'est avéré par la suite qu'un autre élève a contribué à ce projet, mais ce ne fut pas bloquant.

## Contribution

La contribution a été dans mon cas, la partie la plus simple de mon projet. En effet, j'ai seulement dû trouver les fichiers contenant les textes, comportant des erreurs, qui étaient affichés sur le site web et après avoir lu la documentation et la façon de contribuer au projet, j'ai créé mon [issue](https://github.com/ADE-Scheduler/ADE-Scheduler/issues/651) en commentant en dessous pour m'assurer que ce que je pensais faire était correct. Après avoir eu l'approbation, de l'un des mainteneurs d'ADE Scheduler, j'ai cloné un fork du projet, et créé une nouvelle branche où j'ai édité des fichiers json là où c'était nécessaire. En tout, j'ai corrigé 47 fautes d'orthographe et j'ai réalisé lors de ma contribution que 2 liens n'étaient non seulement pas mis à jour, mais également redirigeaient seulement sur une version anglaise qu'importe si l'on consultait la version française ou anglaise d'ADE Scheduler. Je les ai donc modifiés en conséquence.

## Pull Request

Une fois les modifications terminées et après les avoir relues de nombreuses fois, j'ai entamé la dernière étape qui consistait à réaliser le [pull request](https://github.com/ADE-Scheduler/ADE-Scheduler/pull/652). Celui-ci s'est révélé plutôt simple malgré quelques imprévus. 

En effet, après avoir soumis mon pull request, un mainteneur différent de celui avec lequel j'ai précédemment conversé m'a gentiment demandé s'il était tout de même possible que j'exécute quelques commandes de mon côté pour assurer le bon comportement de ma modification, car certains messages simplistes comme "Cancel/Annuler" sont présents dans un fichier .po qui nécessite d'être recompilé après modification. Cependant, j'avais bien fait attention avant de faire ma requête au premier mainteneur qui m'a donné son accord que je n'avais pas besoin de réaliser cela étant donné que les fautes que j'avais trouvées étaient présentes uniquement dans des fichiers json "static" ne demandant aucune compilation. De plus, comme mes changements consistaient seulement en des ajouts et suppressions de caractères dans des textes, et non pas du code ou des fichiers nécessitant une compilation, je n'avais pas besoin d'exécuter tous les tests de mon côté. 

Après avoir mis cela au clair avec le mainteneur, le CI Testing a malheureusement échoué indiquant qu'une exception avait été lancée par une fonction. Très surpris par ce résultat, j'ai enquêté sur les détails de cette erreur et relu assidument mes ajouts, mais je ne trouvais vraiment pas de quelle manière ma contribution pourrait être à l'origine de ce problème. J'ai donc fait part de mon incompréhension face à cette erreur aux mainteneurs du projet et l'un d'eux m'a dit de ne pas m'inquiéter puisqu'en fait elle est produite actuellement avec les pull requests externes au projet et que cela a encore besoin d'être résolu de leur côté. Le mainteneur a alors finalement validé et fusionné mon pull request avec la branche principale.

## Conclusion

En conclusion, alors que ma contribution technique est faible, je pense avoir malgré tout atteint l'objectif principal de ce projet qui consistait à faire un premier pas dans l'open source.

Durant ce projet, j'ai beaucoup appris non pas par ma contribution, mais grâce à mes recherches sur GitHub. En effet, j'ai parcouru énormément de projets et lu de nombreuses issues, et j'ai ainsi été étonné par la manière dont des personnes qui pourtant ne se connaissent pas peuvent être amenées à se réunir, à interagir autour de certains projets et à s'accorder sur ses problématiques. Concernant le projet ADE Scheduler, avant de contribuer, j'ai lu certaines issues ouvertes et fermées pour voir comment cela se passait et j'ai été surpris par la bienveillance et surtout l'ouverture d'esprit de certains des mainteneurs, car bien qu'il s'agisse de leur "bébé", ils conçoivent d'accepter ou de réaliser des changements au projet qu’eux ne désirent pas forcément et en cas de désaccords, procèdent à un vote à la majorité.

Cependant, j'ai également découvert quelques points que je trouve négatifs sur GitHub. Effectivement, j'ai constaté qu’énormément de projets consistaient à refaire mainte et mainte fois la même chose comme réécrire dans différents langages des fonctions triviales, moins optimisées qui plus est, ou recréer des minis-jeux qui existent déjà à de nombreux endroits sur la plateforme. J'ai également découvert un fléau: les personnes qui demandent à être affectées à une tâche et qui ne donnent plus jamais de nouvelles par après sans avoir rien changé. Pour finir, j'ai trouvé que dans les gros projets open source, les issues sont inondées par des demandes de feature d'utilisateurs, sans labels, qui n'ont en plus parfois pas pris la peine de vérifier si celles-ci n'étaient pas déjà discutées auparavant.

Pour être honnête, je comptais au début de cette année faire une bonne contribution plutôt technique et compliquée. J'ai fini par réaliser qu'il n'y avait pas de bonnes ou de mauvaises contributions, mais seulement des contributions dont l'importance et l'utilité varient en fonction des personnes. En effet, certaines personnes, comme moi, aiment faire attention à l'orthographe alors que pour d'autres cela n'a pas d'importance, d'autres encore aiment que leurs données soient totalement sécurisées là où certains se moquent que par exemple leur photo de famille finisse par être publique. Ainsi, toutes les issues et pull requests, n'ont pas forcément la même valeur aux yeux de tous, mais elles n'ont pas à l'être, je pense. Pour terminer, je considère maintenant que la contribution la plus utile à un projet open source ne consiste pas forcément à y participer sur GitHub, mais plutôt d'en faire la publicité autour de nous.
