# Report - Contribution to open source project

| **Author:**              | _Rodrigo Magaldi_                        |
| ------------------------ | ---------------------------------------- |
| **Date:**                | 26/10/2021                               |
| **NOMA:**                | 2622-21-00                               |
| **Academic Year:**       | 2021-2022                                |
| **Open Source Project:** | [Exercism](https://github.com/exercism/) |

## Choice of the project

As soon as I got to know that we were supposed to contribute to an open source project, what came to mind was an npm package I used a lot in my last job, called [brazilian-utils](https://github.com/brazilian-utils/brazilian-utils). Basically, it's a general tool for field validation of Brazilian information (phone number, address, ID number, etc.). However, by the time I checked, there were no simple issues to be resolved, nor was the community particularly active, so I decided to take a look at some other possibilities.

Having never contributed to an open source project before, I was a little lost, so I took a look at what previous students of this course had done, and I found out about Exercism, an open source tool to learn how to program. I had come across this kind of website before, but not Exercism per se, and I was really interested to find out how such a big project was organized.

Thus, Exercism is the project I contributed to. Since I had experience working with Typescript (and strongly typed languages are much better to work with), [this](https://github.com/exercism/) is the track I chose to follow.

## My process

After [studying a little as to how to contribute to an open source project](https://github.com/firstcontributions/first-contributions) and beginning the [learning track of typescript on exercism](https://exercism.org/tracks/typescript) to get acquainted with the service, I thought I was ready to make a contribution.

My first thought, seeing how the description of the exercises was written, was that I could contribute on making the instructions a little clearer for the students, by separating the text in sections, adding inputs and examples of inputs and outputs, so I created an [issue](https://github.com/exercism/typescript/issues/807) at the repo.

However, as was pointed out to me, Exercism is not meant for absolute beginner programmers, so it's not too bad that the instructions don't guide the whole solution to the problem.

In light of that, I decided to contribute by adding an exercise to the track, in which the goal is to translate the colors of a resistor into a human readable label.

## Conclusion

Although I did not put too much work into the actual coding, it was really enlightening to understand how to work at an open source project, and I hope I can make more contributions to Exercism and other projects in the future.
The maintainer was really nice to me and fast in responding to my questions and inputs.

- Issue created: https://github.com/exercism/typescript/issues/807
- PR: https://github.com/exercism/typescript/pull/814

With all tests passed, I'm just waiting for full aproval and finally the merge of my work into the main branch.
